Index: flags.h
===================================================================
--- flags.h	(revision 172693)
+++ flags.h	(working copy)
@@ -112,6 +112,8 @@ extern struct target_flag_state *this_ta
 #define flag_excess_precision \
   (this_target_flag_state->x_flag_excess_precision)
 
+extern int flag_werror_set;
+
 /* Nonzero if we dump in VCG format, not plain text.  */
 extern int dump_for_graph;
 
Index: opts.c
===================================================================
--- opts.c	(revision 172693)
+++ opts.c	(working copy)
@@ -36,6 +36,9 @@ along with GCC; see the file COPYING3.  
 #include "insn-attr.h"		/* For INSN_SCHEDULING and DELAY_SLOTS.  */
 #include "target.h"
 
+
+int flag_werror_set;
+
 /* Parse the -femit-struct-debug-detailed option value
    and set the flag variables. */
 
@@ -1378,6 +1381,10 @@ common_handle_option (struct gcc_options
       /* Currently handled in a prescan.  */
       break;
 
+    case OPT_Werror:
+      flag_werror_set = true;
+      break;
+
     case OPT_Werror_:
       enable_warning_as_error (arg, value, lang_mask, handlers,
 			       opts, opts_set, loc, dc);
Index: opts-global.c
===================================================================
--- opts-global.c	(revision 172693)
+++ opts-global.c	(working copy)
@@ -310,10 +310,7 @@ decode_options (struct gcc_options *opts
 
   set_default_handlers (&handlers);
 
-  /* Enable -Werror=coverage-mismatch by default.  */
-  control_warning_option (OPT_Wcoverage_mismatch, (int) DK_ERROR, true,
-			  loc, lang_mask,
-			  &handlers, opts, opts_set, dc);
+  warn_coverage_mismatch = true;
 
   default_options_optimization (opts, opts_set,
 				decoded_options, decoded_options_count,
@@ -329,6 +326,18 @@ decode_options (struct gcc_options *opts
 			loc, lang_mask,
 			&handlers, dc);
 
+  if (!flag_werror_set)
+    {
+      /* Enable -Werror=coverage-mismatch by default, if it hasn't
+         be set explicitly.  */
+      if (warn_coverage_mismatch
+          && (global_dc->classify_diagnostic[OPT_Wcoverage_mismatch] ==
+          DK_UNSPECIFIED))
+        control_warning_option (OPT_Wcoverage_mismatch, (int) DK_ERROR, true,
+                                loc, lang_mask,
+                                &handlers, opts, opts_set, dc);
+    }
+
   finish_options (opts, opts_set, loc);
 }
 
